/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.129
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.66 2007/05/30 15:45:01 cardoe Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.129 2012/03/22 15:14:53 vapier Exp $
4# 4
5# @ECLASS: autotools.eclass
6# @MAINTAINER:
5# Maintainer: base-system@gentoo.org 7# base-system@gentoo.org
6# 8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
7# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
8# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
9# 12
10# NB: If you add anything, please comment it! 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
11 18
12inherit eutils libtool 19inherit eutils libtool
13 20
14[[ -z ${WANT_AUTOCONF} ]] && WANT_AUTOCONF="latest" 21# @ECLASS-VARIABLE: WANT_AUTOCONF
15[[ -z ${WANT_AUTOMAKE} ]] && WANT_AUTOMAKE="latest" 22# @DESCRIPTION:
23# The major version of autoconf your package needs
24: ${WANT_AUTOCONF:=latest}
25
26# @ECLASS-VARIABLE: WANT_AUTOMAKE
27# @DESCRIPTION:
28# The major version of automake your package needs
29: ${WANT_AUTOMAKE:=latest}
30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
38# @DESCRIPTION:
39# CONSTANT!
40# The latest major version/slot of automake available on each arch. #312315
41# If a newer slot is stable on any arch, and is NOT reflected in this list,
42# then circular dependencies may arise during emerge @system bootstraps.
43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
16 47
17_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
18_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
19if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
20 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
21 # workaround while we have different versions of automake in arch and ~arch
22 none) _automake_atom="" ;; # some packages don't require automake at all 52 none) _automake_atom="" ;; # some packages don't require automake at all
23 latest) _automake_atom="=sys-devel/automake-1.10*" ;; 53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
24 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
25 esac 64 esac
26 [[ ${WANT_AUTOMAKE} == "latest" ]] && WANT_AUTOMAKE="1.10"
27 export WANT_AUTOMAKE 65 export WANT_AUTOMAKE
28fi 66fi
29 67
30if [[ -n ${WANT_AUTOCONF} ]] ; then 68if [[ -n ${WANT_AUTOCONF} ]] ; then
31 case ${WANT_AUTOCONF} in 69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
32 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
33 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
34 esac 75 esac
35 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
36 export WANT_AUTOCONF 76 export WANT_AUTOCONF
37fi 77fi
38DEPEND="${_automake_atom} 78
39 ${_autoconf_atom} 79_libtool_atom="sys-devel/libtool"
40 sys-devel/libtool" 80if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87fi
88
89AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
41RDEPEND="" 90RDEPEND=""
91
92# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93# @DESCRIPTION:
94# Set to 'no' to disable automatically adding to DEPEND. This lets
95# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96# their own DEPEND string.
97: ${AUTOTOOLS_AUTO_DEPEND:=yes}
98if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100fi
101
42unset _automake_atom _autoconf_atom 102unset _automake_atom _autoconf_atom
43 103
44# Variables: 104# @ECLASS-VARIABLE: AM_OPTS
45# 105# @DEFAULT_UNSET
46# AT_M4DIR - Additional director(y|ies) aclocal should search 106# @DESCRIPTION:
47# AM_OPTS - Additional options to pass to automake during 107# Additional options to pass to automake during
48# eautoreconf call. 108# eautoreconf call.
109
110# @ECLASS-VARIABLE: AT_NOEACLOCAL
111# @DEFAULT_UNSET
112# @DESCRIPTION:
113# Don't run eaclocal command if set to 'yes',
114# useful when eaclocal needs to be ran with
115# particular options
116
117# @ECLASS-VARIABLE: AT_NOEAUTOCONF
118# @DEFAULT_UNSET
119# @DESCRIPTION:
120# Don't run eautoconf command if set to 'yes',
121# useful when eautoconf needs to be ran with
122# particular options
123
124# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
125# @DEFAULT_UNSET
126# @DESCRIPTION:
127# Don't run eautomake command if set to 'yes',
128# useful when eautomake needs to be ran with
129# particular options
130
131# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
132# @DEFAULT_UNSET
133# @DESCRIPTION:
49# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 134# Don't run elibtoolize command if set to 'yes',
50# useful when elibtoolize needs to be ran with 135# useful when elibtoolize needs to be ran with
51# particular options 136# particular options
52 137
53# Functions: 138# @ECLASS-VARIABLE: AT_M4DIR
54# 139# @DESCRIPTION:
55# eautoreconf() - Should do a full autoreconf - normally what most people 140# Additional director(y|ies) aclocal should search
56# will be interested in. Also should handle additional 141: ${AT_M4DIR:=}
57# directories specified by AC_CONFIG_SUBDIRS.
58# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
59# to search for macro's.
60# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
61# with elibtoolize() from libtool.eclass
62# eautoconf - Runs autoconf.
63# eautoheader - Runs autoheader.
64# eautomake - Runs automake
65#
66 142
67# XXX: M4DIR should be deprecated 143# @ECLASS-VARIABLE: AT_SYS_M4DIR
68AT_M4DIR=${AT_M4DIR:-${M4DIR}} 144# @INTERNAL
69AT_GNUCONF_UPDATE="no" 145# @DESCRIPTION:
146# For system integrators, a list of additional aclocal search paths.
147# This variable gets eval-ed, so you can use variables in the definition
148# that may not be valid until eautoreconf & friends are run.
149: ${AT_SYS_M4DIR:=}
70 150
71 151# @FUNCTION: eautoreconf
152# @DESCRIPTION:
72# This function mimes the behavior of autoreconf, but uses the different 153# This function mimes the behavior of autoreconf, but uses the different
73# eauto* functions to run the tools. It doesn't accept parameters, but 154# eauto* functions to run the tools. It doesn't accept parameters, but
74# the directory with include files can be specified with AT_M4DIR variable. 155# the directory with include files can be specified with AT_M4DIR variable.
156#
157# Should do a full autoreconf - normally what most people will be interested in.
158# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
75eautoreconf() { 159eautoreconf() {
76 local pwd=$(pwd) x auxdir 160 local x auxdir g
77 161
78 if [[ -z ${AT_NO_RECURSIVE} ]]; then 162 if [[ -z ${AT_NO_RECURSIVE} ]]; then
79 # Take care of subdirs 163 # Take care of subdirs
80 for x in $(autotools_get_subdirs); do 164 for x in $(autotools_get_subdirs); do
81 if [[ -d ${x} ]] ; then 165 if [[ -d ${x} ]] ; then
82 cd "${x}" 166 pushd "${x}" >/dev/null
83 AT_NOELIBTOOLIZE="yes" eautoreconf 167 AT_NOELIBTOOLIZE="yes" eautoreconf
84 cd "${pwd}" 168 popd >/dev/null
85 fi 169 fi
86 done 170 done
87 fi 171 fi
88 172
89 auxdir=$(autotools_get_auxdir) 173 auxdir=$(autotools_get_auxdir)
90 174
175 if [[ ${AT_NOEACLOCAL} != "yes" ]]; then
91 einfo "Running eautoreconf in '$(pwd)' ..." 176 einfo "Running eautoreconf in '${PWD}' ..."
92 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 177 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
93 eaclocal 178 eaclocal
179 fi
180 [[ ${CHOST} == *-darwin* ]] && g=g
181 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
182 _elibtoolize --copy --force --install
183 else
94 _elibtoolize --copy --force 184 _elibtoolize --copy --force
95 eautoconf 185 fi
96 eautoheader 186 [[ ${AT_NOEAUTOCONF} != "yes" ]] && eautoconf
97 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 187 [[ ${AT_NOEAUTOHEADER} != "yes" ]] && eautoheader
188 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
98 189
99 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 190 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
100 191
101 # Call it here to prevent failures due to elibtoolize called _before_ 192 # Call it here to prevent failures due to elibtoolize called _before_
102 # eautoreconf. 193 # eautoreconf. We set $S because elibtoolize runs on that #265319
103 elibtoolize 194 S=${PWD} elibtoolize --force
104 195
105 return 0 196 return 0
106} 197}
107 198
199# @FUNCTION: eaclocal_amflags
200# @DESCRIPTION:
201# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
202# (most) of the crazy crap that people throw at us.
203eaclocal_amflags() {
204 local aclocal_opts amflags_file
205
206 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
207 [[ -e ${amflags_file} ]] || continue
208 # setup the env in case the pkg does something crazy
209 # in their ACLOCAL_AMFLAGS. like run a shell script
210 # which turns around and runs autotools. #365401
211 # or split across multiple lines. #383525
212 autotools_env_setup
213 aclocal_opts=$(sed -n \
214 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
215 # match the first line
216 s:[^=]*=::p; \
217 # then gobble up all escaped lines
218 : nextline /\\\\$/{ n; p; b nextline; } \
219 }" ${amflags_file})
220 eval aclocal_opts=\""${aclocal_opts}"\"
221 break
222 done
223
224 echo ${aclocal_opts}
225}
226
227# @FUNCTION: eaclocal
228# @DESCRIPTION:
108# These functions runs the autotools using autotools_run_tool with the 229# These functions runs the autotools using autotools_run_tool with the
109# specified parametes. The name of the tool run is the same of the function 230# specified parametes. The name of the tool run is the same of the function
110# without e prefix. 231# without e prefix.
111# They also force installing the support files for safety. 232# They also force installing the support files for safety.
233# Respects AT_M4DIR for additional directories to search for macro's.
112eaclocal() { 234eaclocal() {
113 local aclocal_opts
114
115 if [[ -n ${AT_M4DIR} ]] ; then
116 for x in ${AT_M4DIR} ; do
117 case "${x}" in
118 "-I")
119 # We handle it below
120 ;;
121 *)
122 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
123 aclocal_opts="${aclocal_opts} -I ${x}"
124 ;;
125 esac
126 done
127 fi
128
129 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 235 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
130 autotools_run_tool aclocal "$@" ${aclocal_opts} 236 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
131} 237}
132 238
239# @FUNCTION: _elibtoolize
240# @DESCRIPTION:
241# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
242# libtool.eclass.
133_elibtoolize() { 243_elibtoolize() {
134 local opts 244 local opts g=
135 local lttest
136 245
137 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 246 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
138 # check for both it and the current AC_PROG_LIBTOOL) 247 # check for both it and the current AC_PROG_LIBTOOL)
139 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 248 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
140 [[ -n $lttest ]] || return 0
141 249
142 [[ -f Makefile.am ]] && opts="--automake" 250 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
143 251
144 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 252 [[ ${CHOST} == *-darwin* ]] && g=g
145 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 253 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
146 254
147 # Need to rerun aclocal 255 # Need to rerun aclocal
148 eaclocal 256 eaclocal
149} 257}
150 258
259# @FUNCTION: eautoheader
260# @DESCRIPTION:
261# Runs autoheader.
151eautoheader() { 262eautoheader() {
152 # Check if we should run autoheader 263 # Check if we should run autoheader
153 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 264 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
154 NO_FAIL=1 autotools_run_tool autoheader "$@" 265 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
155} 266}
156 267
268# @FUNCTION: eautoconf
269# @DESCRIPTION:
270# Runs autoconf.
157eautoconf() { 271eautoconf() {
158 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 272 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
159 echo 273 echo
160 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 274 eerror "No configure.{ac,in} present in '${PWD}'!"
161 echo 275 echo
162 die "No configure.{ac,in} present!" 276 die "No configure.{ac,in} present!"
163 fi 277 fi
164 278
165 autotools_run_tool autoconf "$@" 279 autotools_run_tool --at-m4flags autoconf "$@"
166} 280}
167 281
282# @FUNCTION: eautomake
283# @DESCRIPTION:
284# Runs automake.
168eautomake() { 285eautomake() {
169 local extra_opts 286 local extra_opts
287 local makefile_name
170 288
171 [[ -f Makefile.am ]] || return 0 289 # Run automake if:
290 # - a Makefile.am type file exists
291 # - the configure script is using the AM_INIT_AUTOMAKE directive
292 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
293 [[ -f ${makefile_name} ]] && break
294 done
172 295
296 if [[ -z ${makefile_name} ]] ; then
297 # Really we should just use autotools_check_macro ...
298 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
299 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
300 return 0
301 fi
302
173 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 303 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
174 local used_automake 304 local used_automake
175 local installed_automake 305 local installed_automake
176 306
177 installed_automake=$(automake --version | head -n 1 | \ 307 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
178 sed -e 's:.*(GNU automake) ::') 308 sed -e 's:.*(GNU automake) ::')
179 used_automake=$(head -n 1 < Makefile.in | \ 309 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
180 sed -e 's:.*by automake \(.*\) from .*:\1:') 310 sed -e 's:.*by automake \(.*\) from .*:\1:')
181 311
182 if [[ ${installed_automake} != ${used_automake} ]]; then 312 if [[ ${installed_automake} != ${used_automake} ]]; then
183 einfo "Automake used for the package (${used_automake}) differs from" 313 einfo "Automake used for the package (${used_automake}) differs from"
184 einfo "the installed version (${installed_automake})." 314 einfo "the installed version (${installed_automake})."
185 eautoreconf 315 eautoreconf
186 return 0 316 return 0
187 fi 317 fi
188 fi 318 fi
189 319
190 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 320 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
191 || extra_opts="${extra_opts} --foreign" 321 || extra_opts="${extra_opts} --foreign"
192 322
193 # --force-missing seems not to be recognized by some flavours of automake 323 # --force-missing seems not to be recognized by some flavours of automake
194 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 324 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
195} 325}
196 326
327# @FUNCTION: eautopoint
328# @DESCRIPTION:
329# Runs autopoint (from the gettext package).
330eautopoint() {
331 autotools_run_tool autopoint "$@"
332}
333
334# @FUNCTION: config_rpath_update
335# @USAGE: [destination]
336# @DESCRIPTION:
337# Some packages utilize the config.rpath helper script, but don't
338# use gettext directly. So we have to copy it in manually since
339# we can't let `autopoint` do it for us.
340config_rpath_update() {
341 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
342
343 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
344 [[ $# -eq 0 ]] && return 0
345
346 einfo "Updating all config.rpath files"
347 for dst in "$@" ; do
348 einfo " ${dst}"
349 cp "${src}" "${dst}" || die
350 done
351}
352
197# Internal function to run an autotools' tool 353# Internal function to run an autotools' tool
354autotools_env_setup() {
355 # We do the "latest" → version switch here because it solves
356 # possible order problems, see bug #270010 as an example.
357 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
358 local pv
359 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
360 # has_version respects ROOT, but in this case, we don't want it to,
361 # thus "ROOT=/" prefix:
362 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
363 done
364 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
365 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
366 fi
367 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
368}
198autotools_run_tool() { 369autotools_run_tool() {
370 # Process our own internal flags first
371 local autofail=true m4flags=false
372 while [[ -n $1 ]] ; do
373 case $1 in
374 --at-no-fail) autofail=false;;
375 --at-m4flags) m4flags=true;;
376 # whatever is left goes to the actual tool
377 *) break;;
378 esac
379 shift
380 done
381
382 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
383 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
384 fi
385
386 autotools_env_setup
387
199 local STDERR_TARGET="${T}/$$.out" 388 local STDERR_TARGET="${T}/$1.out"
389 # most of the time, there will only be one run, but if there are
390 # more, make sure we get unique log filenames
391 if [[ -e ${STDERR_TARGET} ]] ; then
200 local ris 392 local i=1
393 while :; do
394 STDERR_TARGET="${T}/$1-${i}.out"
395 [[ -e ${STDERR_TARGET} ]] || break
396 : $(( i++ ))
397 done
398 fi
201 399
202 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 400 if ${m4flags} ; then
203 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 401 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
402 fi
403
404 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
204 405
205 ebegin "Running $@" 406 ebegin "Running $@"
206 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 407 "$@" >> "${STDERR_TARGET}" 2>&1
207 ris=$? 408 if ! eend $? && ${autofail} ; then
208 eend ${ris}
209
210 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
211 echo 409 echo
212 eerror "Failed Running $1 !" 410 eerror "Failed Running $1 !"
213 eerror 411 eerror
214 eerror "Include in your bugreport the contents of:" 412 eerror "Include in your bugreport the contents of:"
215 eerror 413 eerror
216 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 414 eerror " ${STDERR_TARGET}"
217 echo 415 echo
218 die "Failed Running $1 !" 416 die "Failed Running $1 !"
219 fi 417 fi
220} 418}
221 419
222# Internal function to check for support 420# Internal function to check for support
223autotools_check_macro() { 421autotools_check_macro() {
224 [[ -f configure.ac || -f configure.in ]] && \ 422 [[ -f configure.ac || -f configure.in ]] || return 0
225 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 423 local macro
424 for macro ; do
425 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
426 done
226 return 0 427 return 0
227} 428}
228 429
430# Internal function to look for a macro and extract its value
431autotools_check_macro_val() {
432 local macro=$1 scan_out
433
434 autotools_check_macro "${macro}" | \
435 gawk -v macro="${macro}" \
436 '($0 !~ /^[[:space:]]*(#|dnl)/) {
437 if (match($0, macro ":(.*)$", res))
438 print res[1]
439 }' | uniq
440
441 return 0
442}
443
229# Internal function to get additional subdirs to configure 444# Internal function to get additional subdirs to configure
230autotools_get_subdirs() { 445autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
231 local subdirs_scan_out 446autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
232 447
233 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 448_autotools_m4dir_include() {
234 [[ -n ${subdirs_scan_out} ]] || return 0 449 local x include_opts
235 450
236 echo "${subdirs_scan_out}" | gawk \ 451 for x in "$@" ; do
237 '($0 !~ /^[[:space:]]*(#|dnl)/) { 452 case ${x} in
238 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 453 # We handle it below
239 print res[1] 454 -I) ;;
240 }' | uniq 455 *)
456 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
457 include_opts+=" -I ${x}"
458 ;;
459 esac
460 done
241 461
242 return 0 462 echo ${include_opts}
243} 463}
464autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
465autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
244 466
245autotools_get_auxdir() { 467fi
246 local auxdir_scan_out
247
248 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
249 [[ -n ${auxdir_scan_out} ]] || return 0
250
251 echo ${auxdir_scan_out} | gawk \
252 '($0 !~ /^[[:space:]]*(#|dnl)/) {
253 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
254 print res[1]
255 }' | uniq
256
257 return 0
258}

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.129

  ViewVC Help
Powered by ViewVC 1.1.20